module PuntosPoint
  class Api
    attr_reader :client

    def initialize(env = nil)
      @env = env
      @@config ||= PuntosPoint::Config.new(@env)
      @@wsdl_url ||= @@config.wsdl_url
      @client = ::Savon.client(wsdl: @@wsdl_url, headers: { 'Authentication' => @@config.api_password })
    end

    def get_events
      @client.call(:get_events)
        .body[:get_events_response][:value] rescue nil
    end

    def get_event(event_id)
      @client.call(:get_event, message: { event_id: event_id })
        .body[:get_event_response][:value] rescue nil
    end

    def create_purchase(rut, email, exchange_id, references_codes = nil)
      @client.call(:create_purchase,
                   message: {
                       rut: rut,
                       email: email,
                       exchange_id: exchange_id,
                       reference_codes: references_codes
                   })
              .body[:create_purchase_response][:value] rescue nil
    end

    def confirm_purchase(purchase_id)
      @client.call(:confirm_purchase, message: { purchase_id: purchase_id })
        .body[:confirm_purchase_response][:value] rescue nil
    end

    def redeem_purchase(purchase_id)
      @client.call(:redeem_purchase, message: { purchase_id: purchase_id })
        .body[:redeem_purchase_response][:value] rescue nil
    end
  end
end